////// exo3v2.sci: //////
// exec exo3v2.sci


function y=plus(x)
y=(x+abs(x))/2;
endfunction

function y=plus2(x)
y=x*(x+abs(x))/2;
endfunction





function y=h1(x)
y=x(1)^2+x(2)^2-1;
endfunction

function y=h2(x)
y=1-x(1)-x(2);
endfunction

function y=h1plus2(x)
y=plus2(h1(x));
endfunction

function y=h2plus2(x)
y=plus2(h2(x));
endfunction

function y=hplus2(x)
y=h1plus2(x)+h2plus2(x);
endfunction



function y=h(x)
y=h1(x)^2+h2(x)^2;
endfunction

function y=dh1(x)
y=2*x;
endfunction

function y=dh2(x)
y=-ones(x);
endfunction

function y=dh1plus2(x)
y=(h1(x)+abs(h1(x)))*dh1(x);
endfunction

function y=dh2plus2(x)
y=(h2(x)+abs(h2(x)))*dh2(x);
endfunction

function y=dhplus2(x)
y=dh1plus2(x)+dh2plus2(x);
endfunction


function y=dh(x)
y=2*h1(x)*dh1(x)+2*h2(x)*dh2(x);
endfunction


function z=g1(x,y)
z=x^2-y;
endfunction

function y=g(x)
y=x(1)^2-x(2);
endfunction

function y=dg(x)
y=x;
y(1)=2*y(1);
y(2)=-1;
endfunction


function y=hplus2g(x)
y=hplus2(x)/1024+g(x); //hplus2(x)+g(x)/256;
endfunction

function y=dhplus2g(x)
y=dhplus2(x)/1024+dg(x); //dhplus2(x)+dg(x)/256;
endfunction


function y=pK(x)

y=x;
x1=x(1);
x2=x(2);
r=x1^2+x2^2;
s=x1+x2;
d=x2-x1;

if (r>=1)&(s>=1) then
   if x2<=0 then
     y(1)=1;
     y(2)=0;
   elseif (x1<=0) then
     y(1)=0;
     y(2)=1;
   else
     y=x/sqrt(r);
   end
end

if (s<=1) then
   if (d>=1) then 
      y(1)=0;
      y(2)=1;
   elseif (d<=-1) then
      y(1)=1;
      y(2)=0;
   else 
      y(1)=(1-d)/2;
      y(2)=(1+d)/2;
   end
end

    
endfunction

function [y,z]=pasfixeproj(rho,df,x)

z=x-rho*df(x);
y=pK(z);

endfunction

function y=pasfixe(rho,df,x)

y=x-rho*df(x);


endfunction

function y=pasfixepen(param,rho,df,x)

eps=1e-6;

x1=x(1);
x2=x(2);
gx=h1(x);
dgx=dh1(x);

dy=df(x)+(gx+abs(gx))*dg(x)/param;

gx=h2(x);
dgx=dh2(x);
dy=dy+(gx+abs(gx))*dg(x)/param;

y=x-rho*dy;



endfunction




close()
xx=-1:0.01:1;
yy1=sqrt(1-xx.^2);
yy2=-yy1;

plot(xx,yy1)
plot(xx,yy2)

xx=-2:0.01:3;
yy1=1-xx;
plot(xx,yy1)

t=-2:0.01:2;
contour2d(t,t,g1,20)


x=[0;0];
y=pK(x)
y1=y(1);
y2=y(2);
xx=0:0.01:y1;
yy=0:0.01:y2;
plot(xx,yy)
plot(0,0,'*',y1,y2,'o')


x=[1;1];
y=pK(x)
y1=y(1);
y2=y(2);
xx=y1:0.01:1;
yy=y2:0.01:1;
plot(xx,yy)
plot(1,1,'*',y1,y2,'o')

x=[0;2];
y=pK(x)
y1=y(1);
y2=y(2);

yy=1:0.01:2;
xx=zeros(yy);
plot(xx,yy)
plot(0,2,'*',y1,y2,'o')


x=[-1;1.5];
y=pK(x)
y1=y(1);
y2=y(2);
xx=-1:0.01:y1;
yy=1-xx/2;
plot(xx,yy)
plot(-1,1.5,'*',y1,y2,'o')


x=[2;-1.5];
y=pK(x)
y1=y(1);
y2=y(2);
xx=y1:0.01:2;
yy=-3*(xx-1)/2;
plot(xx,yy)
plot(2,-1.5,'*',y1,y2,'o')

rho=1; // 0.1;
eps=1e-6; //0.001;
x=[-1;1.5];//[1;1];//[-1;-1];//[0;0];//
tabx=[x];
taby=[x];

test=1;
k=0;

while (test>eps)&(k<50)
[x,y]=pasfixeproj(rho,dg,x);
tabx=[tabx,x];
taby=[taby,y];
test=abs(g(x)+1);
k=k+1;
end

test
k
x

xx1=tabx(1,:);
xx2=tabx(2,:);
x1=xx1(1);
x2=xx2(1);
x3=xx1($);
x4=xx2($);

xy1=taby(1,:);
xy2=taby(2,:);
y1=xy1(1);
y2=xy2(1);
y3=xy1($);
y4=xy2($);


close()
xx=-1:0.01:1;
yy1=sqrt(1-xx.^2);
yy2=-yy1;

plot(xx,yy1)
plot(xx,yy2)

xx=-2:0.01:3;
yy1=1-xx;
plot(xx,yy1)

plot(xx1,xx2,x1,x2,'*',x3,x4,'o')
plot(xy1,xy2,y1,y2,'*',y3,y4,'x')

/////////// Penalisation: ////

rho=0.01; //0.1; // 0.01; //0.1;
param=1e-6; //0.001;
eps=1e-6; // 0.01;

x0=[-2;-4]; //[2;-2]; //[-2;-1]; //[2;-1.5];//[-2;0]; //[-2;-1]; //[-2; 1]; //[-1;0]; 
//[0;0]; //[-1;-1]; //[0;0];
test=1;
k=0;

tabx0=[x0]; 

//for i=1:3

k=0;

while (test>eps)&(k<480)
x0=pasfixe(rho,dhplus2g,x0); // pasfixe(rho,dhplus2,x0); //x0=pasfixe(rho,dh,x0);
tabx0=[tabx0,x0];
test=abs(hplus2g(x0)+1);
k=k+1;

end

//end // i
test
k
x0

close()
xx=-1:0.01:1;
yy1=sqrt(1-xx.^2);
yy2=-yy1;

plot(xx,yy1)
plot(xx,yy2)

xx=-2:0.01:3;
yy1=1-xx;
plot(xx,yy1)

x01=tabx0(1,:);
x02=tabx0(2,:);
x1=x01(1);
x2=x02(1);
x3=x01($);
x4=x02($);


plot(x01,x02,x1,x2,'*',x3,x4,'o')


