////// exo4v2.sci: //////
// exec exo4v2.sci

function z=dE(l1,l2,x,y)

z=[2*(l1-3); l2-2; 0; 0];

endfunction

function z=dg(l1,l2,x,y)

r=sqrt(x^2+y^2);
r3=sqrt((x-3)^2+y^2);
z=[1 0 -x/r -y/r;
0 1 -(x-3)/r3 -y/r3;
0 0 8*(x-3/2)/9 y/2];

endfunction

function z=paslag(l1,l2,x,y) // coefficients de Lagrange par moindres carres

a=dg(l1,l2,x,y);
b=a*dE(l1,l2,x,y);

z=a*a'\b;

endfunction

close()
xx=0:0.01:3;
yy=2*sqrt(1-4*(xx-1.5).^2/9);
plot(xx,yy)


//tabi=[1 2 3 4];
tabx0=[1.5 1 2 0.1 2.7];
taby0=[2 1 1 0.4 0.2];

d=length(tabx0);

for i=1:d
x0=tabx0(i);
y0=taby0(i);

//x0=0.1; //2; // 1; //1.5;
//y0=0.4; //1; //1; //2;
l10=sqrt(x0^2+y0^2);
l20=sqrt((x0-3)^2+y0^2);

test=1;
k=0;
eps=1e-6;

tabx=[x0];
taby=[y0];

while (test>eps)&(k<50)
//for k=1:10
z=paslag(l10,l20,x0,y0);
l1=3+z(1)/2;
l12=l1^2;
l2=2+z(2);
x=(l12-l2^2)/6+3/2;
tabx=[tabx,x];
//y=sqrt(l12-x^2);
y=2*sqrt(1-4*(x-1.5)^2/9);
taby=[taby,y];
test=abs(x-x0)+abs(y-y0)+abs(l1-l10)+abs(l2-l20);
k=k+1;
l10=l1;
l20=l2;
x0=x;
y0=y;
end

test
k
x
y



plot(tabx,taby,'--o')

x1=0:0.01:x;
x2=y*x1/x;
plot(x1,x2)

x1=x:0.01:3;
x2=y*(x1-3)/(x-3);
plot(x1,x2,x,y,'*')

end
